AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Cart.cshtml.cs
using AdventureWorks.Context;
using AdventureWorks.Models;
using AdventureWorks.Web.Configuration;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Options;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace AdventureWorks.Web.Pages
{
    public class Cart : PageModel
    {
        private readonly Settings _settings;
        private readonly IAdventureWorksProductContext _productContext;
        private readonly IAdventureWorksCheckoutContext _checkoutContext;

        public Cart(IOptions<Settings> settings, IAdventureWorksProductContext productContext, IAdventureWorksCheckoutContext checkoutContext)
        {
            _settings = settings.Value;
            _productContext = productContext;
            _checkoutContext = checkoutContext;
        }

        [BindProperty]
        public List<Product> Products { get; set; } = new List<Product>();

        public async Task OnGetAsync(Guid? add)
        {
            if (_settings.CartAvailable)
            {
                if (add.HasValue)
                {
                    Product product = await _productContext.FindProductAsync(add.Value);
                    await _checkoutContext.AddProductToCartAsync(_settings.UniqueIdentifier, product);
                }
                this.Products = await _checkoutContext.GetProductsInCartAsync(_settings.UniqueIdentifier);
            }
        }

        public async Task<ActionResult> OnPostClearAsync()
        {
            await _checkoutContext.ClearCart(_settings.UniqueIdentifier);
            return Page();
        }

        public ActionResult OnPostCheckout()
        {
            return RedirectToPage(nameof(Checkout));
        }
    }
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Checkout.cshtml.cs
using AdventureWorks.Context;
using AdventureWorks.Models;
using AdventureWorks.Web.Configuration;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Options;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace AdventureWorks.Web.Pages
{
    public class Checkout : PageModel
    {
        private readonly Settings _settings;
        private readonly IAdventureWorksCheckoutContext _checkoutContext;

        public Checkout(IOptions<Settings> settings, IAdventureWorksCheckoutContext checkoutContext)
        {
            _settings = settings.Value;
            _checkoutContext = checkoutContext;
        }

        [BindProperty]
        public Guid OrderNumber { get; set; } = Guid.Empty;

        [BindProperty]
        public List<Product> Products { get; set; } = new List<Product>();

        public async Task OnGetAsync()
        {
            if (_settings.CartAvailable)
            {
                var products = await _checkoutContext.GetProductsInCartAsync(_settings.UniqueIdentifier);
                await _checkoutContext.ClearCart(_settings.UniqueIdentifier);

                this.Products = products;
                this.OrderNumber = Guid.NewGuid();
            }
        }
    }
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Details.cshtml.cs
using AdventureWorks.Context;
using AdventureWorks.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System;
using System.ComponentModel.DataAnnotations;
using System.Threading.Tasks;

namespace AdventureWorks.Web.Pages
{
    public class Details : PageModel
    {
        private readonly IAdventureWorksProductContext _productContext;

        public Details(IAdventureWorksProductContext productContext)
        {
            _productContext = productContext;
        }

        [BindProperty(SupportsGet = true)]
        public Model Model { get; set; }

        [BindProperty, Required(ErrorMessage = "Please select a product.")]
        public string SelectedProductId { get; set; } = String.Empty;

        public async Task OnGetAsync(Guid id)
        {
            this.Model = await _productContext.FindModelAsync(id);
        }

        public async Task<ActionResult> OnPostAsync(Guid id)
        {
            if (!ModelState.IsValid)
            {
                this.Model = await _productContext.FindModelAsync(id);
                return Page();
            }
            Guid selectedProductId = Guid.Parse(this.SelectedProductId);
            return RedirectToPage(nameof(Cart), new { add = selectedProductId });
        }
    }
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Index.cshtml.cs
using AdventureWorks.Context;
using AdventureWorks.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace AdventureWorks.Web.Pages
{
    public class Index : PageModel
    {
        private readonly IAdventureWorksProductContext _productContext;

        public Index(IAdventureWorksProductContext productContext)
        {
            _productContext = productContext;
        }

        [BindProperty(SupportsGet = true)]
        public List<Model> Models { get; set; } = new List<Model>();

        public async Task OnGetAsync()
        {
            this.Models = await _productContext.GetModelsAsync();
        }
    }
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Cart.cshtml
@page "{add:guid?}"
@model Cart
@inject IOptions<Settings> Settings
@{ 
    decimal totalPrice = Model.Products.Sum(p => p.ListPrice);
}
<div class="text-center pb-3">
    <h1 class="display-4">
        Shopping Cart
    </h1>
</div>
@if (Settings.Value.CartAvailable)
{
    @if (Model.Products.Any())
    {
        <ul class="list-unstyled">
            @foreach (var product in Model.Products)
            {
                <li class="media d-flex justify-content-between">
                    <img src="@Flurl.Url.Combine(Settings.Value?.BlobContainerUrl, @product.Photo)" class="mr-3" alt="@product.Name">
                    <div class="media-body">
                        <h3 class="mt-0 mb-1">
                            @product.Name
                        </h3>
                        <p class="text-muted">@product.Category</p>
                    </div>
                    <div class="text-right font-weight-bold">
                        @($"{product.ListPrice:C}")
                    </div>
                </li>
            }
        </ul>
        <div class="d-flex justify-content-between">
            <form asp-page-handler="Clear" method="post">
                <button type="submit" class="btn btn-secondary">Clear</button>
            </form>
            <form asp-page-handler="Checkout" method="post">
                <button type="submit" class="btn btn-secondary">Checkout</button>
            </form>
            <span class="text-right text-uppercase font-weight-bolder">
                Total: @($"{totalPrice:C}")
            </span>
        </div>
    }
    else
    {
        <div class="jumbotron text-center">
            <div class="container">
                <p class="lead">
                    Your cart is currently empty.
                </p>
            </div>
        </div>
    }
}
else
{
    <div class="jumbotron bg-danger text-light">
        <h1 class="display-4">Checkout is disabled!</h1>
        <p class="lead">Enable checkout using the <code class="text-white-50">Settings.CartAvailable</code> configuration setting.</p>
    </div>
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Checkout.cshtml
@page
@model Checkout
@inject IOptions<Settings> Settings
@{
    decimal totalPrice = Model.Products.Sum(p => p.ListPrice);
}
<div class="text-center pb-3">
    <h1 class="display-4">
        Thanks for Checking Out!
    </h1>
</div>
@if (Settings.Value.CartAvailable)
{
    <p class="lead">
        Your order number is:
        <span class="badge badge-secondary m-1">
            @Model.OrderNumber
        </span>
    </p>
    <table class="table table-striped table-bordered">
        <thead>
            <tr>
                <th scope="col">Name</th>
                <th scope="col">Category</th>
                <th scope="col">Price</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var product in Model.Products)
            {
                <tr>
                    <th scope="row">
                        @product.Name
                    </th>
                    <td>
                        @product.Category
                    </td>
                    <td class="text-right font-weight-bold">
                        @($"{product.ListPrice:C}")
                    </td>
                </tr>
            }
        </tbody>
        <tfoot>
            <tr>
                <th scope="row" class="text-right text-uppercase font-weight-bolder" colspan="3">
                    @($"{totalPrice:C}")
                </th>
            </tr>
        </tfoot>
    </table>
}
else
{
    <div class="jumbotron bg-danger text-light">
        <h1 class="display-4">Checkout is disabled!</h1>
        <p class="lead">Enable checkout using the <code class="text-white-50">Settings.CartAvailable</code> configuration setting.</p>
    </div>
}

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Details.cshtml
@page "{id:guid}"
@model Details
@inject IOptions<Settings> Settings
@{
    List<SelectListItem> modelList = Model.Model.Products.Select(p => new SelectListItem { Value = p.id.ToString(), Text = $"{p.Name}, {p.ListPrice:C}" }).ToList();
}
<article class="row">
    <section class="col-md-8">
        <img src="@Flurl.Url.Combine(Settings.Value?.BlobContainerUrl, Model.Model.Photo)" class="img-thumbnail img-fluid w-100 shadow-sm" alt="@Model.Model.Name" />
    </section>
    <aside class="col-md-4">
        <div class="card shadow-sm">
            <div class="card-header">
                <h4 class="font-weight-normal">@Model.Model.Name</h4>
            </div>
            <div class="card-body">
                <h3 class="card-title">
                    <span class="text-nowrap text-muted">
                        @($"{Model.Model.Products.Average(p => p.ListPrice):C}")
                    </span>
                </h3>
                <form method="post">
                    <div class="form-group">
                        <label asp-for="SelectedProductId">
                            Select Options
                        </label>
                        <select asp-for="SelectedProductId" asp-items="modelList" class="form-control">
                            @if (modelList.Count >= 2)
                            {
                                <option value="">Select an option</option>
                            }
                        </select>
                        <span asp-validation-for="SelectedProductId" class="text-danger"></span>
                    </div>
                    <button type="submit" class="btn btn-info btn-lg btn-block">
                        <i class="fas fa-shopping-cart ml-2"></i>
                        Add to Cart
                    </button>
                </form>
            </div>
        </div>
    </aside>
</article>
<summary class="mt-3">
    <div class="card bg-light shadow-sm">
        <div class="card-body">
            <h5 class="card-title">
                @Model.Model.Description
            </h5>
        </div>
    </div>
</summary>

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Index.cshtml
@page
@model Index
@inject IOptions<Settings> Settings
@{
    ViewData["Home"] = true;
}
<article class="card-columns">
    @foreach (var item in Model.Models)
    {
        <div class="card">
            <img src="@Flurl.Url.Combine(Settings.Value?.BlobContainerUrl, item.Photo)" class="card-img-top" alt="@item.Name">
            <div class="card-body">
                <h5 class="card-title">
                    @item.Name
                </h5>
                <p class="card-text">
                    <small class="text-muted">
                        @item.Description
                    </small>
                </p>
            </div>
            <div class="card-footer">
                <a asp-page="@nameof(Details)" asp-route-id="@item.id" class="card-link">
                    View Details
                </a>
            </div>
        </div>
    }
</article>

AZ-203-DevelopingSolutionsforMicrosoftAzure/Allfiles/Labs/03/Solution/AdventureWorks/AdventureWorks.Web/Pages/Shared/_Layout.cshtml
@inject IOptions<Settings> Settings
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
    <title>
        Adventure Works
    </title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/css/all.min.css" integrity="sha256-UzFD2WYH2U1dQpKDjjZK72VtPeWP50NoJjd26rnAdUI=" crossorigin="anonymous" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/js/all.min.js" integrity="sha256-xzrHBImM2jn9oDLORlHS1/0ekn1VyypEkV1ALvUx8lU=" crossorigin="anonymous"></script>
</head>
<body>
    <nav class="navbar navbar-dark bg-info">
        <div class="container">
            <a class="navbar-brand mr-auto" asp-page="@nameof(Index)">
                Adventure Works
            </a>
            @if (Settings.Value.CartAvailable)
            {
                <div class="form-inline my-2 my-lg-0">
                    <a class="btn btn-info my-2 my-sm-0" asp-page="@nameof(Cart)">
                        <span class="fa-layers fa-fw fa-2x">
                            <i class="fas fa-shopping-cart"></i>
                        </span>
                    </a>
                </div>
            }
        </div>
    </nav>
    @if (ViewData.ContainsKey("Home"))
    {
        <header class="card text-center border-0">
            <img src="~/mountains.jpg" class="card-img-top img-fluid" alt="Photo by Dan Gold on Unsplash">
            <div class="card-img-overlay" style="background-color: rgba(15, 15, 15, 0.65);">
                <div class="container">
                    <h1 class="jumbotron-heading display-1 text-light">
                        Adventure Works
                    </h1>
                    <p class="lead text-white-50 font-weight-lighter font-italic">
                        Cycling products for the adventerous among us
                    </p>
                </div>
            </div>
        </header>
    }
    <main class="container py-3">
        @RenderBody()
    </main>
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.1/jquery.validate.min.js" integrity="sha256-sPB0F50YUDK0otDnsfNHawYmA5M0pjjUf4TvRJkGFrI=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validation-unobtrusive/3.2.11/jquery.validate.unobtrusive.min.js" integrity="sha256-9GycpJnliUjJDVDqP0UEu/bsm9U+3dnQUH8+3W10vkY=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
</body>
</html>